include graphics.e
include image.e
include machine.e
include ememcopy.e
include get.e
include file.e
include mistfont.e
-- New virtual graphics manipulator,
-- spf files generator
-- 1997 Eduardo Uemura Okada

-- from Pete Eberlein
global constant wait_retrace = allocate(20)
poke(wait_retrace, {
	   #50,        -- PUSH EAX
	   #52,        -- PUSH EDX
	   #BA,#DA,3,0,0,-- MOV EDX, 0x03DA
	   #EC,        -- IN AL, DX
	   #24,#08,    -- AND AL, 0x08
	   #75,#FB,    -- JNZ $-5
	   #EC,        -- IN AL, DX
	   #24,#08,    -- AND AL, 0x08
	   #74,#FB,    -- JZ $-5
	   #5A,        -- POP EDX
	   #58,        -- POP EAX
	   #C3 })      -- RET

-- global variables to store some data:
-- image_log=  {id,adress,x_size,y_size,place}
-- sprite_log= {id,adress,x_size,y_size,place}
-- virtual_log={id,adress,x_size,y_size}

global sequence image_log,sprite_log,virtual_log
	image_log  = repeat(0,500)
	sprite_log = repeat(0,500)
	virtual_log= repeat(0,500)

atom x
x=set_up_emc()

global function reduce_deep(sequence data)
	sequence reduced
	reduced={}
	for times=1 to length(data) do
		reduced=reduced&data[times]
	end for
	return reduced
end function

global function grow_deep(sequence data,atom x_elements,atom y_elements)
	atom x
	sequence new
	
	x=1

	new=repeat(0,y_elements)
	for times=1 to y_elements do
		for again=1 to x_elements do
			new[times]=repeat(0,x_elements)
		end for
	end for

	for times=1 to y_elements do
		for again=1 to x_elements do
			new[times][again]=data[x]
			x=x+1
		end for
	end for

	return new
end function

global procedure wait(atom times)
	atom t
	tick_rate(1000)
	t=time()+times
	while time()<t do
	end while
	tick_rate(0)
end procedure

global procedure new_virtual_screen(atom id,sequence xy)
	atom adress
	integer x_size,y_size
	sequence clear
	if sequence(virtual_log[id]) then
		free(virtual_log[id][2])
		virtual_log[id]=0
	end if
	adress=allocate(xy[1]*xy[2])
	x_size=xy[1]
	y_size=xy[2]
	clear=repeat(0,xy[1]*xy[2])
	poke(adress,clear)
	virtual_log[id]={id,adress,x_size,y_size}
end procedure


-- intermediatte virtual screen
-- to solve slowdown problem
new_virtual_screen(500,{320,200})


global procedure clear_virtual_screen(atom id)
	sequence clear
	clear=repeat(0,virtual_log[id][3]*virtual_log[id][4])
	poke(virtual_log[id][2],clear)
end procedure

global procedure delete_virtual_screen(atom id)
	free(virtual_log[id][2])
	virtual_log[id]=0
end procedure

global procedure virtual_save_back(atom id,atom page)
	object adress,screen_adress
	integer x_size,y_size
	sequence place,end_place
	if sequence(image_log[id]) then
		free(image_log[id][2])
		image_log[id]=0
	end if
	x_size=sprite_log[id][3]
	y_size=sprite_log[id][4]
	place = sprite_log[id][5]
	end_place={place[1]+x_size,place[2]+y_size}
	adress=allocate(x_size*y_size)
	screen_adress=virtual_log[page][2]
	se_mem_copy(1,screen_adress+place[1]+place[2]*virtual_log[page][3],adress,x_size,y_size,virtual_log[page][3]-x_size,0)
	image_log[id]={id,adress,x_size,y_size,place}
end procedure

global procedure virtual_clear_sprite(atom id,atom page)
	atom adress,screen_adress
	integer x_size,y_size,x_screen,y_screen
	sequence place
	adress=image_log[id][2]
	screen_adress=virtual_log[page][2]
	x_size=image_log[id][3]
	y_size=image_log[id][4]
	x_screen=virtual_log[page][3]
	y_screen=virtual_log[page][4]
	place=sprite_log[id][5]
	se_mem_copy(	1,
				adress,
				screen_adress+place[1]+place[2]*x_screen,
				x_size,
				y_size,
				0,
				x_screen-x_size)
end procedure

global procedure allocate_sprite(atom id,sequence data)
	atom adress
	integer x_size,y_size
	if sequence(sprite_log[id]) then
		free(sprite_log[id][2])
		sprite_log[id]=0
	end if
	x_size=length(data[1])
	y_size=length(data)
	data=reduce_deep(data)
	adress=allocate(length(data))
	poke(adress,data)
	sprite_log[id]={id,adress,x_size,y_size,{0,0}}
end procedure

global procedure delete_sprite(atom id)
	free(sprite_log[id][2])
	sprite_log[id]=0
end procedure

global procedure allocate_image(atom id,sequence data)
	atom adress
	integer x_size,y_size
	if sequence(image_log[id]) then
		free(sprite_log[id][2])
		sprite_log[id]=0
	end if
	x_size=length(data[1])
	y_size=length(data)
	data=reduce_deep(data)
	adress=allocate(length(data))
	poke(adress,data)
	image_log[id]={id,adress,x_size,y_size,{0,0}}
end procedure

global procedure delete_image(atom id)
	free(image_log[id][2])
	image_log[id]=0
end procedure

global procedure virtual_display_image(atom id,atom page,sequence place)
	atom adress,screen_adress
	integer x_size,y_size,x_screen,y_screen
	adress=image_log[id][2]
	screen_adress=virtual_log[page][2]
	x_size=image_log[id][3]
	y_size=image_log[id][4]
	x_screen=virtual_log[page][3]
	y_screen=virtual_log[page][4]
	image_log[id][5]=place
	se_mem_copy(1,adress,screen_adress+place[1]+place[2]*x_screen,x_size,y_size,0,x_screen-x_size)
end procedure

global procedure virtual_put_sprite(atom id, atom page, sequence place)
	atom adress,screen_adress
	integer x_size,y_size,x_screen,y_screen
	sprite_log[id][5]=place
	adress=sprite_log[id][2]
	screen_adress=virtual_log[page][2]
	x_size=sprite_log[id][3]
	y_size=sprite_log[id][4]
	x_screen=virtual_log[page][3]
	y_screen=virtual_log[page][4]
	virtual_save_back(id,page)
	se_mem_copy(2,adress,screen_adress+place[1]+place[2]*x_screen,x_size,y_size,0,x_screen-x_size)
end procedure

global procedure virtual_paste_sprite(atom id, atom page, sequence place)
	atom adress,screen_adress
	integer x_size,y_size,x_screen,y_screen
	adress=sprite_log[id][2]
	screen_adress=virtual_log[page][2]
	x_size=sprite_log[id][3]
	y_size=sprite_log[id][4]
	x_screen=virtual_log[page][3]
	y_screen=virtual_log[page][4]
	se_mem_copy(1,adress,screen_adress+place[1]+place[2]*x_screen,x_size,y_size,0,x_screen-x_size)
end procedure

global procedure display_virtual_screen(atom id,sequence place)
	atom adress1,adress2,page1,page2,adress
	integer x_size1,y_size1,x_size2,y_size2
	page1=id
	page2=500
	adress1=virtual_log[page1][2]
	x_size1=virtual_log[page1][3]
	y_size1=virtual_log[page1][4]
	adress2=virtual_log[page2][2]
	x_size2=virtual_log[page2][3]
	y_size2=virtual_log[page2][4]
	se_mem_copy(1,adress1+place[1]+place[2]*x_size1,
				adress2,
				320,
				200,
				x_size1-320,
				0)
	adress=virtual_log[500][2]
	call(wait_retrace)
	mem_copy(#A0000,adress,64000)
end procedure	

global procedure put_sprite(atom id, sequence place, atom effect)
	atom adress,counter
	integer x_size,y_size
	sequence sprite,data
	x_size=sprite_log[id][3]
	y_size=sprite_log[id][4]
	adress=sprite_log[id][2]
	sprite=peek({adress,x_size*y_size})
	data=repeat(0,y_size)
	counter=1
	for times=1 to length(data) do
		data[times]=sprite[counter..counter+x_size-1]
		counter=counter+x_size
	end for
	if effect=1 then
		display_image(place,data)
	elsif effect=2 then
		sprite=save_image(place,{place[1]+x_size,place[2]+y_size})
		while compare(sprite,data)<=0 do
		for x=1 to length(data) do
			for y=1 to length(data[x]) do
				if sprite[x][y]>data[x][y] then
					sprite[x][y]=sprite[x][y]-1
				elsif sprite[x][y]<data[x][y] then
					sprite[x][y]=sprite[x][y]+1
				elsif sprite[x][y]=data[x][y] then
					sprite[x][y]=sprite[x][y]
				end if
			end for
		end for
		call(wait_retrace)
		wait(.1)
		display_image(place,sprite)
		end while
	end if
end procedure

global procedure change_image(sequence data2,sequence data1,sequence place,atom time)
	while compare(data1,data2)!=0 do
		for x=1 to length(data1) do
			for y=1 to length(data1[x]) do
				if data2[x][y]>data1[x][y] then
					data2[x][y]=data2[x][y]-1
				elsif data2[x][y]<data1[x][y] then
					data2[x][y]=data2[x][y]+1
				elsif data2[x][y]=data1[x][y] then
					data2[x][y]=data1[x][y]
				end if
			end for
		end for
		call(wait_retrace)
		wait(time)
		display_image(place,data2)
	end while
end procedure

global procedure convert_bitmaps(sequence filenames,sequence name)
	atom number
	sequence temp, paleta,images,data,x_size,y_size

	temp=read_bitmap(filenames[1])
	paleta=temp[1]
	paleta[17]={0,0,0}
	paleta=reduce_deep(paleta)
	for times=1 to length(paleta) do
		if paleta[times]=256 then
			paleta[times]=255
		elsif paleta[times]=13 then
			paleta[times]=1
		end if
	end for

	images=repeat(0,length(filenames))
	x_size=repeat(0,length(filenames))
	y_size=repeat(0,length(filenames))

	for times=1 to length(images) do
		temp={}

		temp=read_bitmap(filenames[times])
		data=temp[2]
		x_size[times]=length(data[1])
		y_size[times]=length(data)

		data=reduce_deep(data)

		images[times]=data
	end for

	for times=1 to length(images) do
		for again=1 to length(images[times]) do
			if images[times][again]=13 then
				images[times][again]=255
			end if
		end for
	end for

	-- writing to the file

	number=open(name,"w")
	puts(number,paleta)
	for times=1 to length(images) do
		puts(number,x_size[times])
		puts(number,y_size[times])
		puts(number,images[times])
	end for
	close(number)
end procedure

global function load_bitmaps(sequence name)
	atom number
	sequence images,paleta,x_size,y_size
	object temp

	x_size={}
	y_size={}
	images={}
	temp={}

	number=open(name,"r")

	for times=1 to 768 do
		temp=append(temp,getc(number))
	end for

	for times=1 to 768 do
		if temp[times]=-1 then
			temp[times]=26
		elsif temp[times]=1 then
			temp[times]=13
		end if
	end for

	paleta=grow_deep(temp,3,256)

	temp=0

	-- Palette loaded, now
	-- loading bitmaps
	while 1 do
		temp=getc(number)
		if temp=-1 then
			close(number)
			exit
		elsif temp=255 then
			temp=13
		end if
		x_size=append(x_size,temp)
		temp=0
		temp=getc(number)
		if temp=-1 then
			temp=26
		elsif temp=255 then
			temp=13
		end if
		y_size=append(y_size,temp)
		temp={}

		for times=1 to y_size[length(y_size)] do
			for again=1 to x_size[length(x_size)] do
				temp=append(temp,getc(number))
			end for
		end for

		for times=1 to x_size[length(x_size)]*y_size[length(y_size)] do
			if temp[times]=-1 then
				temp[times]=26
			elsif temp[times]=255 then
				temp[times]=13
			end if
		end for

		temp=grow_deep(temp,x_size[length(x_size)],y_size[length(y_size)])

		images=append(images,temp)

	end while

	return {paleta,images}
end function

global function check_contact_with_tiles(atom id,sequence map,atom tile_size,sequence solid_tiles)
	sequence coordinate_in_map,tiles,contacted

	tiles={0,0,0,0}
	contacted={0,0,0,0}	
	-- first zero is the leftmost tile
	-- second zero is the rightmost tile
	-- third zero is the upmost tile
	-- fourth zero is the downmost tile

	-- determining the coordinates of the objects
	coordinate_in_map=floor({sprite_log[id][5][1]/tile_size,sprite_log[id][5][2]/tile_size})
	tiles[1]={coordinate_in_map[1]-1,coordinate_in_map[2]} -- leftmost tile
	tiles[2]={coordinate_in_map[1]+1,coordinate_in_map[2]} -- rightmost tile
	tiles[3]={coordinate_in_map[1],coordinate_in_map[2]-1} -- upmost tile
	tiles[4]={coordinate_in_map[1],coordinate_in_map[2]+1} -- downmost tile

	-- checking for sprite in the borders
	for times=1 to 4 do
		for again=1 to 2 do
			if tiles[times][again]<=0 then
				tiles[times][again]=1
			end if
		end for
	end for

	for times=1 to 4 do -- loop to determine how many tiles are in contact
		for again=1 to length(solid_tiles) do -- loop to see if tile is solid
			if map[tiles[times][2]][tiles[times][1]]=solid_tiles[again] then -- if solid
				contacted[times]=1 -- tile is set to true
			end if
		end for
	end for

	return contacted
end function

global function check_contact(atom id1, atom id2, atom tolerance_width)
	sequence place1,place2,contacted

	contacted={0,0,0,0}

	place1=floor({sprite_log[id1][5][1]/tolerance_width,sprite_log[id1][5][2]/tolerance_width})
	place2=floor({sprite_log[id2][5][1]/tolerance_width,sprite_log[id2][5][2]/tolerance_width})

	if place1[1]=place2[1]-1 then
		contacted[1]=1
	elsif place1[1]=place2[1]+1 then
		contacted[2]=1
	elsif place1[2]=place2[2]-1 then
		contacted[3]=1
	elsif place1[2]=place2[2]+1 then
		contacted[4]=1
	end if

	return contacted
end function

global function make_text_box(sequence init,sequence data,atom fore,object color)
	sequence saved_fore,endit

	endit={init[1]+(length(data[1])*5),init[2]+(length(data)*4)+length(data)}+4
	saved_fore=save_image(init,endit)

	polygon(BLUE,1,{init,{endit[1],init[2]},endit,{init[1],endit[2]},init})
	polygon(79,1,{init+1,{endit[1]-1,init[2]+1},endit-1,{init[1]+1,endit[2]-1},init+1})
	polygon(fore,1,{init+2,{endit[1]-2,init[2]+2},endit-2,{init[1]+2,endit[2]-2},init+2})

	for times=1 to length(data) do
		new_print_sequence(init+3,data[times],color,256,1,1)
		init[2]=init[2]+5
	end for

	return saved_fore
end function

global procedure fade_text_box(sequence place,sequence data)
	for times=1 to length(data) do
		pixel(data[times],place)
		place[2]=place[2]+1
		wait(.01)
	end for
end procedure

global procedure allocate_sprites(sequence name,atom start_id)
	atom screen
	sequence temp,palete
	temp=load_bitmaps(name)
	palete=temp[1]/4
	temp=temp[2]
	for times=1 to length(temp) do
		allocate_sprite(start_id,temp[times])
		start_id=start_id+1
	end for
	palete[17]={0,0,0}
	screen=graphics_mode(19)
	--all_palette(palete)
end procedure

global procedure delete_sprites(sequence ids)
	for times=1 to length(ids) do
		delete_sprite(ids[times])
	end for
end procedure

global procedure save_map(sequence map, sequence tile_file, sequence file)
	atom x_size, y_size, file_number, tile_size

	tile_size=length(tile_file)
	y_size=length(map)
	x_size=length(map[1])

	map=reduce_deep(map)
	tile_file=reduce_deep(tile_file)

	file_number=open(file,"w")

	-- character 13 (return)
	-- is invisible to file!

	for times=1 to length(map) do
		if map[times]=13 then
			map[times]=255 -- extrapolating that any map will have 255 tiles!
		end if
	end for

	puts(file_number,tile_size)
	puts(file_number,tile_file)
	puts(file_number,x_size)
	puts(file_number,y_size)
	puts(file_number,map)

	close(file_number)
end procedure

global function load_map(sequence filename)
	atom file_number, x_size, y_size, tile_size
	sequence map, tile_file, to_return

	file_number=open(filename,"r")

	tile_size=getc(file_number)
	tile_file=repeat(0,tile_size)
	for times=1 to tile_size do
		tile_file[times]=getc(file_number)
	end for

	x_size=getc(file_number)
	if x_size=-1 then x_size=26
	end if
	y_size=getc(file_number)
	if y_size=-1 then y_size=26
	end if

	map=repeat(0,x_size*y_size)

	map=grow_deep(map,x_size,y_size)

	for times=1 to y_size do
		for again=1 to x_size do
			map[times][again]=getc(file_number)
			if map[times][again]=-1 then
				map[times][again]=26
			end if
		end for
	end for

	close(file_number)

	for times=1 to length(map) do
		for again=1 to length(map[times]) do
			if map[times][again]=255 then
				map[times][again]=13
			end if
		end for
	end for

	to_return={tile_file,map}
	return to_return
end function
