include image.e
include wildcard.e

function zoom_line(atom times, sequence data)
	
	-- declaring variables
	sequence temp
	atom counter

	-- checking for times out of range
	if times<1 or times>10 then
		puts(1,"\nMagnify times is out of range!\n")
		puts(1,"Acceptable values from 1 to 10!")
		abort(1)
	end if

	-- code
	counter=1

	temp=repeat(1,(length(data)*times))
	for looping=1 to length(data) do
		for count=1 to times do
			temp[counter]=data[looping]
			counter=counter+1
		end for
	end for


	return temp

end function

global function zoom_sequence(sequence data,atom times)

	atom counter
	sequence amply,to_return

	-- checking for value out of range
	if times<1 or times>10 then
		puts(1,"Some value in zoom_place is out of range!")
		puts(1,"\tCould be times>10 or times<1 !")
		abort(1)
	end if

	amply=repeat(0,length(data))
	counter=1

	for x=1 to length(data) do
		amply[x]=zoom_line(times,data[x])
	end for

	to_return=repeat(0,length(amply)*times)
	for x=1 to length(amply) do
		for d=1 to times do
			to_return[counter]=amply[x]
			counter=counter+1
		end for
	end for
	return to_return
end function

global constant MASKED=1
global constant NO_MASKED=0
sequence a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,one,two,three,four,five,six
sequence seven,eight,nine,zero,space,point,exclamation,aspas,virgula

a={{0,1,0,0,0},
   {1,0,1,0,0},
   {1,1,1,0,0},
   {1,0,1,0,0}}

b={{1,1,0,0,0},
   {1,1,1,0,0},
   {1,0,1,0,0},
   {1,1,0,0,0}}

c={{0,1,1,0,0},
   {1,0,0,0,0},
   {1,0,0,0,0},
   {0,1,1,0,0}}

d={{1,1,0,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0},
   {1,1,0,0,0}}

e={{1,1,0,0,0},
   {1,1,0,0,0},
   {1,0,0,0,0},
   {1,1,0,0,0}}

f={{1,1,0,0,0},
   {1,0,0,0,0},
   {1,1,0,0,0},
   {1,0,0,0,0}}

g={{0,1,1,1,0},
   {1,0,0,0,0},
   {1,0,1,1,0},
   {0,1,1,0,0}}

h={{1,0,1,0,0},
   {1,1,1,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0}}

i={{1,1,1,0,0},
   {0,1,0,0,0},
   {0,1,0,0,0},
   {1,1,1,0,0}}

j={{0,1,1,1,0},
   {0,0,1,0,0},
   {1,0,1,0,0},
   {0,1,0,0,0}}

k={{1,0,1,0,0},
   {1,1,0,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0}}

l={{1,0,0,0,0},
   {1,0,0,0,0},
   {1,0,0,0,0},
   {1,1,0,0,0}}

m={{1,0,0,0,1},
   {1,1,0,1,1},
   {1,0,1,0,1},
   {1,0,0,0,1}}

n={{1,0,0,1,0},
   {1,1,0,1,0},
   {1,0,1,1,0},
   {1,0,0,1,0}}

o={{0,1,0,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0},
   {0,1,0,0,0}}

p={{1,1,0,0,0},
   {1,0,1,0,0},
   {1,1,0,0,0},
   {1,0,0,0,0}}

q={{0,1,0,0,0},
   {1,0,1,0,0},
   {1,1,1,0,0},
   {0,1,1,0,0}}

r={{1,1,0,0,0},
   {1,0,1,0,0},
   {1,1,0,0,0},
   {1,0,1,0,0}}

s={{0,1,0,0,0},
   {1,0,0,0,0},
   {0,1,0,0,0},
   {1,0,0,0,0}}

t={{1,1,1,0,0},
   {0,1,0,0,0},
   {0,1,0,0,0},
   {0,1,0,0,0}}

u={{1,0,1,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0},
   {1,1,1,0,0}}

v={{1,0,1,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0},
   {0,1,0,0,0}}

w={{1,0,0,0,1},
   {1,0,0,0,1},
   {1,0,1,0,1},
   {0,1,0,1,1}}

x={{1,0,1,0,0},
   {0,1,0,0,0},
   {1,0,1,0,0},
   {1,0,1,0,0}}

y={{1,0,1,0,0},
   {1,0,1,0,0},
   {0,1,0,0,0},
   {0,1,0,0,0}}

z={{1,1,1,0,0},
   {0,0,1,0,0},
   {0,1,0,0,0},
   {1,1,1,0,0}}

one={{0,1,0,0,0},
     {1,1,0,0,0},
     {0,1,0,0,0},
     {0,1,0,0,0}}

two={{1,1,1,0,0},
     {0,0,1,0,0},
     {0,1,0,0,0},
     {1,1,1,0,0}}

three={{1,1,1,0,0},
       {0,1,0,0,0},
       {0,0,1,0,0},
       {1,1,0,0,0}}

four={{1,0,1,0,0},
      {1,1,1,0,0},
      {0,0,1,0,0},
      {0,0,1,0,0}}

five={{1,1,1,0,0},
      {1,1,0,0,0},
      {0,0,1,0,0},
      {1,1,0,0,0}}

six={{1,1,1,0,0},
     {1,1,0,0,0},
     {1,0,1,0,0},
     {0,1,0,0,0}}

seven={{1,1,0,0,0},
       {0,1,0,0,0},
       {1,1,1,0,0},
       {0,1,0,0,0}}

eight={{0,1,1,0,0},
       {1,0,0,1,0},
       {0,1,1,0,0},
       {1,0,0,1,0}}

nine={{0,1,0,0,0},
      {1,0,1,0,0},
      {0,1,1,0,0},
      {0,0,1,0,0}}

zero={{0,1,1,0,0},
      {1,1,0,1,0},
      {1,0,1,1,0},
      {0,1,1,0,0}}

space={{0,0,0,0,0},
       {0,0,0,0,0},
       {0,0,0,0,0},
       {0,0,0,0,0}}

point={{0,0,0,0,0},
       {0,0,0,0,0},
       {0,0,0,0,0},
       {0,0,1,0,0}}

exclamation={{0,0,1,0,0},
             {0,0,1,0,0},
             {0,0,0,0,0},
             {0,0,1,0,0}}

aspas={{0,1,0,1,0},
       {0,1,0,1,0},
       {0,0,0,0,0},
       {0,0,0,0,0}}

virgula={{0,0,0,0,0},
         {0,0,0,0,0},
         {0,0,0,1,0},
         {0,0,1,0,0}}

global function give_char(atom char)
	sequence temp
	if char='a' then
		temp=a
	elsif char='b' then
		temp=b
	elsif char='c' then
		temp=c
	elsif char='d' then
		temp=d
	elsif char='e' then
		temp=e
	elsif char='f' then
		temp=f
	elsif char='g' then
		temp=g
	elsif char='h' then
		temp=h
	elsif char='i' then
		temp=i
	elsif char='j' then
		temp=j
	elsif char='k' then
		temp=k
	elsif char='l' then
		temp=l
	elsif char='m' then
		temp=m
	elsif char='n' then
		temp=n
	elsif char='o' then
		temp=o
	elsif char='p' then
		temp=p
	elsif char='q' then
		temp=q
	elsif char='r' then
		temp=r
	elsif char='s' then
		temp=s
	elsif char='t' then
		temp=t
	elsif char='u' then
		temp=u
	elsif char='v' then
		temp=v
	elsif char='w' then
		temp=w
	elsif char='x' then
		temp=x
	elsif char='y' then
		temp=y
	elsif char='z' then
		temp=z
	elsif char='0' then
		temp=zero
	elsif char='1' then
		temp=one
	elsif char='2' then
		temp=two
	elsif char='3' then
		temp=three
	elsif char='4' then
		temp=four
	elsif char='5' then
		temp=five
	elsif char='6' then
		temp=six
	elsif char='7' then
		temp=seven
	elsif char='8' then
		temp=eight
	elsif char='9' then
		temp=nine
	elsif char=' ' then
		temp=space
	elsif char='.' then
		temp=point
	elsif char='!' then
		temp=exclamation
	elsif char='"' then
		temp=aspas
	elsif char=',' then
		temp=virgula
	end if
	return temp
end function



global procedure new_print_char(sequence place,atom char,object color,object backcolor,atom status,atom size)
	sequence temp
	temp=give_char(char)
	if status=1 and sequence(backcolor) then
		puts(1,"Status need  to  be  zero,\n")
		puts(1,"to add foreground texture!")
		abort(1)
	end if
	if atom(color) then
		for times=1 to length(temp) do
			for again=1 to length(temp[times]) do
				if temp[times][again]=1 then
					temp[times][again]=color
				end if
			end for
		end for
	end if
	if sequence(color) then
		if atom(color[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=1 then
						temp[times][again]=color[times]
					end if
				end for
			end for
		elsif sequence(color[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=1 then
						temp[times][again]=color[times][again]
					end if
				end for
			end for
		end if
	end if
	if atom(backcolor) then
		for times=1 to length(temp) do
			for again=1 to length(temp[times]) do
				if temp[times][again]=0 then
					temp[times][again]=backcolor
				end if
			end for
		end for
	elsif sequence(backcolor) then
		if atom(backcolor[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=0 then
						temp[times][again]=backcolor[times]
					end if
				end for
			end for
		elsif sequence(backcolor[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=0 then
						temp[times][again]=backcolor[times][again]
					end if
				end for
			end for
		end if
	end if
	temp=zoom_sequence(temp,size)
	if status=1 then
		for times=1 to length(temp) do
			for again=1 to length(temp[times]) do
				if temp[times][again]!=backcolor then
					pixel(temp[times][again],place)
				end if
				place[1]=place[1]+1
			end for
		place[2]=place[2]+1
		place[1]=place[1]-length(temp[1])
		end for
	elsif status=0 then
		display_image(place,temp)
	end if
end procedure

global function new_return_char(atom char,object color,object backcolor,atom size)
	sequence temp
	temp=give_char(char)
	if atom(color) then
		for times=1 to length(temp) do
			for again=1 to length(temp[times]) do
				if temp[times][again]=1 then
					temp[times][again]=color
				end if
			end for
		end for
	end if
	if sequence(color) then
		if atom(color[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=1 then
						temp[times][again]=color[times]
					end if
				end for
			end for
		elsif sequence(color[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=1 then
						temp[times][again]=color[times][again]
					end if
				end for
			end for
		end if
	end if
	if atom(backcolor) then
		for times=1 to length(temp) do
			for again=1 to length(temp[times]) do
				if temp[times][again]=0 then
					temp[times][again]=backcolor
				end if
			end for
		end for
	elsif sequence(backcolor) then
		if atom(backcolor[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=0 then
						temp[times][again]=backcolor[times]
					end if
				end for
			end for
		elsif sequence(backcolor[1]) then
			for times=1 to length(temp) do
				for again=1 to length(temp[times]) do
					if temp[times][again]=0 then
						temp[times][again]=backcolor[times][again]
					end if
				end for
			end for
		end if
	end if
	temp=zoom_sequence(temp,size)
	return temp
end function

global procedure new_print_sequence(sequence place,sequence char,object color,object backcolor,atom status,atom size)
	char=lower(char)
	if atom(char[1]) then
		for times=1 to length(char) do
			new_print_char(place,char[times],color,backcolor,status,size)
			place[1]=place[1]+5*size
		end for
	elsif sequence(char[1]) then
		for times=1 to length(char) do
			for again=1 to length(char[times]) do
				new_print_char(place,char[times][again],color,backcolor,status,size)
				place[1]=place[1]+5*size
			end for
			place[2]=place[2]+4*size
			place[1]=place[1]-length(char[1])*5*size
		end for
	end if
end procedure

global function new_return_sequence(sequence char,object color,object backcolor,atom size)
	sequence text
	char=lower(char)
	text=repeat(0,length(char))
	for times=1 to length(char) do
		text[times]=new_return_char(char[times],color,backcolor,size)
	end for
	return text
end function
